/********************************************************* BTCA2ALite *************************************************************

   BTCA2ALite     
   BTController Lite  .

   : v 1.0

   :   (ZSeregaA)   

   ,     <  >

  :  BTCA2ALite    snes 
   BTController Lite.  BTCA2A      http://robocontroller.ru

************************************************************************************************************************************/


#include "BTCA2ALite.h"

btca2aLite::btca2aLite(){

}

void btca2aLite::SetupHardwareSerial(byte Number, long speed){
  PortNum = Number;
  switch(Number){
  case 0:
    Serial.begin(speed);
    break;
#if defined(UBRR1H)
  case 1:
    Serial1.begin(speed);
    break;
#endif
#if defined(UBRR2H)
  case 2:
    Serial2.begin(speed);
    break;
#endif
#if defined(UBRR3H)
  case 3:
    Serial3.begin(speed);
    break;
#endif
  }
}

void btca2aLite::SerialChoise(){
  keycode = 0;
  switch (PortNum){
  case 0:
    if (Serial.available()>2){
      for (i = 0; i < 3; i++){
        BTvalue = Serial.read();
        BTdata[i] = BTvalue;
      }	
      keycode = BTdata[0]*100 + BTdata[1];
    }
    else 
      return;
    break;

#if defined(UBRR1H)  
  case 1:
    if (Serial1.available()>2){
      for (i = 0; i < 3; i++){
        BTvalue = Serial1.read();
        BTdata[i] = BTvalue;
      }
      keycode = BTdata[0]*100 + BTdata[1];	
    }
    else 
      return;
    break;  
#endif

#if defined(UBRR2H)  
  case 2:
    if (Serial2.available()>2){
      for (i = 0; i < 3; i++){
        BTvalue = Serial2.read();
        BTdata[i] = BTvalue;
      }
      keycode = BTdata[0]*100 + BTdata[1];	
    }
    else 
      return;
    break;  
#endif

#if defined(UBRR3H)  
  case 3:
    if (Serial3.available()>2){
      for (i = 0; i < 3; i++){
        BTvalue = Serial3.read();
        BTdata[i] = BTvalue;
      }
      keycode = BTdata[0]*100 + BTdata[1];	
    }
    else 
      return;
    break;  
#endif  
  }
}

void btca2aLite::ReadCommand(){

  SerialChoise();

  if (keycode == 0)  // ,    
    return; 

  //------------------------- START CHECK COMMANDS ------------------------------------

  switch (keycode){

  // -------- KEYCODE_BUTTON_L1 -----------
  case 5454:
    switch (BTdata[2]){
    case 68:
      buttonState[KEYCODE_BUTTON_L1] = true;
      commandID = KEYCODE_BUTTON_L1;
      break;

    case 85:
      buttonState[KEYCODE_BUTTON_L1] = false;
      break;
    }
    break;

  // -------- KEYCODE_BUTTON_L2 -----------
  case 5456:
    switch (BTdata[2]){
    case 68:
      buttonState[KEYCODE_BUTTON_L2] = true;
      commandID = KEYCODE_BUTTON_L2;
      break;

    case 85:
      buttonState[KEYCODE_BUTTON_L2] = false;
      break;
    }
    break;

  // -------- KEYCODE_BUTTON_START -----------
  case 5467:
    switch (BTdata[2]){
    case 68:
      buttonState[KEYCODE_BUTTON_START] = true;
      commandID = KEYCODE_BUTTON_START;
      break;

    case 85:
      buttonState[KEYCODE_BUTTON_START] = false;
      break;
    }
    break;

  // -------- KEYCODE_BUTTON_SELECT -----------
  case 5468:
    switch (BTdata[2]){
    case 68:
      buttonState[KEYCODE_BUTTON_SELECT] = true;
      commandID = KEYCODE_BUTTON_SELECT;
      break;

    case 85:
      buttonState[KEYCODE_BUTTON_SELECT] = false;
      break;
    }
    break;

  // -------- KEYCODE_BUTTON_R1 -----------
  case 5455:
    switch (BTdata[2]){
    case 68:
      buttonState[KEYCODE_BUTTON_R1] = true;
      commandID = KEYCODE_BUTTON_R1;
      break;

    case 85:
      buttonState[KEYCODE_BUTTON_R1] = false;
      break;
    }
    break;

  // -------- KEYCODE_BUTTON_R2 -----------
  case 5457:
    switch (BTdata[2]){
    case 68:
      buttonState[KEYCODE_BUTTON_R2] = true;
      commandID = KEYCODE_BUTTON_R2;
      break;

    case 85:
      buttonState[KEYCODE_BUTTON_R2] = false;
      break;
    }
    break;

  // -------- KEYCODE_BUTTON_Y -----------
  case 5452:
    switch (BTdata[2]){
    case 68:
      buttonState[KEYCODE_BUTTON_Y] = true;
      commandID = KEYCODE_BUTTON_Y;
      break;

    case 85:
      buttonState[KEYCODE_BUTTON_Y] = false;
      break;
    }
    break;

  // -------- KEYCODE_BUTTON_X -----------
  case 5451:
    switch (BTdata[2]){
    case 68:
      buttonState[KEYCODE_BUTTON_X] = true;
      commandID = KEYCODE_BUTTON_X;
      break;

    case 85:
      buttonState[KEYCODE_BUTTON_X] = false;
      break;
    }
    break;

  // -------- KEYCODE_BUTTON_B -----------
  case 5449:
    switch (BTdata[2]){
    case 68:
      buttonState[KEYCODE_BUTTON_B] = true;
      commandID = KEYCODE_BUTTON_B;
      break;

    case 85:
      buttonState[KEYCODE_BUTTON_B] = false;
      break;
    }
    break;

  // -------- KEYCODE_BUTTON_A -----------
  case 5448:
    switch (BTdata[2]){
    case 68:
      buttonState[KEYCODE_BUTTON_A] = true;
      commandID = KEYCODE_BUTTON_A;
      break;

    case 85:
      buttonState[KEYCODE_BUTTON_A] = false;
      break;
    }
    break;

  // -------- KEYCODE_DPAD_LEFT -----------
  case 4953:
    switch (BTdata[2]){
    case 68:
      buttonState[KEYCODE_DPAD_LEFT] = true;
      commandID = KEYCODE_DPAD_LEFT;
      break;

    case 85:
      buttonState[KEYCODE_DPAD_LEFT] = false;
      break;
    }
    break;

  // -------- KEYCODE_DPAD_UP -----------
  case 4951:
    switch (BTdata[2]){
    case 68:
      buttonState[KEYCODE_DPAD_UP] = true;
      commandID = KEYCODE_DPAD_UP;
      break;

    case 85:
      buttonState[KEYCODE_DPAD_UP] = false;
      break;
    }
    break;

  // -------- KEYCODE_DPAD_DOWN -----------
  case 4952:
    switch (BTdata[2]){
    case 68:
      buttonState[KEYCODE_DPAD_DOWN] = true;
      commandID = KEYCODE_DPAD_DOWN;
      break;

    case 85:
      buttonState[KEYCODE_DPAD_DOWN] = false;
      break;
    }
    break;

  // -------- KEYCODE_DPAD_RIGHT -----------
  case 4954:
    switch (BTdata[2]){
    case 68:
      buttonState[KEYCODE_DPAD_RIGHT] = true;
      commandID = KEYCODE_DPAD_RIGHT;
      break;

    case 85:
      buttonState[KEYCODE_DPAD_RIGHT] = false;
      break;
    }
    break;

  }

}

boolean btca2aLite::Button(unsigned char buttonID) {
  boolean results = false;

  if (buttonID == commandID){
    commandID = 0;
    results = true;
  }

  return results;
}

boolean btca2aLite::ButtonPressed(unsigned char buttonID) {
  boolean results = false;
  results = buttonState[buttonID];
  return results;
}

boolean btca2aLite::ButtonReleased(unsigned char buttonID) {
  boolean results = false;
  if(!buttonState[buttonID]){
    results = true;
  }
  return results;
}