/********************************************************* BTCA2ALite *************************************************************

   BTCA2ALite     
   BTController Lite  .

   : v 1.0

   :   (ZSeregaA)   

   ,     <>

  :  BTCA2ALite    snes 
   BTController Lite.  BTCA2A      http://robocontroller.ru

************************************************************************************************************************************/

#ifndef BTCA2ALite_H
#define BTCA2ALite_H

#include <Arduino.h>

//----------- BTController buttons -----------

#define KEYCODE_DPAD_LEFT    1
#define KEYCODE_DPAD_UP      2
#define KEYCODE_DPAD_DOWN    3
#define KEYCODE_DPAD_RIGHT   4

#define KEYCODE_BUTTON_A       5
#define KEYCODE_BUTTON_B       6
#define KEYCODE_BUTTON_X       7
#define KEYCODE_BUTTON_Y       8
#define KEYCODE_BUTTON_R1      9
#define KEYCODE_BUTTON_R2      10
#define KEYCODE_BUTTON_L1      11
#define KEYCODE_BUTTON_L2      12
#define KEYCODE_BUTTON_SELECT  13
#define KEYCODE_BUTTON_START   14

//----------------------------------------------

class btca2aLite {
public:
  btca2aLite();
  void SetupHardwareSerial(unsigned char Number, long speed);
  void ReadCommand();
  boolean Button(unsigned char);
  boolean ButtonPressed(unsigned char);
  boolean ButtonReleased(unsigned char);

private:
  void SerialChoise();
  boolean buttonState[15];
  unsigned char BTdata[3];
  unsigned int keycode;
  unsigned char commandID;
  unsigned char BTvalue;
  unsigned char i;
  unsigned char PortNum;

};

#endif